# Generated by using Rcpp::compileAttributes() -> do not edit by hand
# Generator token: 10BE3573-1514-4C36-9D1C-5A225CD40393

bijectionvector <- function(K) {
    .Call(`_errum_bijectionvector`, K)
}

inv_bijectionvector <- function(K, CL) {
    .Call(`_errum_inv_bijectionvector`, K, CL)
}

CL_invbijection_table <- function(K, nClass) {
    .Call(`_errum_CL_invbijection_table`, K, nClass)
}

#' Generate Multinomial Random Variable
#'
#' Sample a multinomial random variable for given probabilities.
#'
#' @param ps A \code{vector} for the probability of each category.
#'
#' @return
#' A \code{vector} from a multinomial with probability ps.
#'
#' @author
#' Steven Andrew Culpepper
#'
#' @noRd
rmultinomial <- function(ps) {
    .Call(`_errum_rmultinomial`, ps)
}

#' Generate Dirichlet Random Variable
#'
#' Sample a Dirichlet random variable.
#'
#' @param deltas A \code{vector} of Dirichlet parameters.
#'
#' @return
#' A \code{vector} from a Dirichlet.
#'
#' @author
#' Steven Andrew Culpepper
#'
#' @noRd
rDirichlet <- function(deltas) {
    .Call(`_errum_rDirichlet`, deltas)
}

random_Q <- function(J, K) {
    .Call(`_errum_random_Q`, J, K)
}

simrRUM <- function(N, J, K, Q, rstar, pistar, CLASS) {
    .Call(`_errum_simrRUM`, N, J, K, Q, rstar, pistar, CLASS)
}

DEVIANCErRUM <- function(N, J, K, nClass, Y, rstar, pistar, pis) {
    .Call(`_errum_DEVIANCErRUM`, N, J, K, nClass, Y, rstar, pistar, pis)
}

simgnida <- function(N, J, K, Q, B0, B1, CLASS) {
    .Call(`_errum_simgnida`, N, J, K, Q, B0, B1, CLASS)
}

rTruncNorm <- function(mean, sd, w) {
    .Call(`_errum_rTruncNorm`, mean, sd, w)
}

parm_update_nomiss <- function(N, J, K, nClass, Y, X_biject, B0, B1, CLASS, pis, Q, MU, vv, CLtable, v0, v1, d0, pistar, rstar, a0, b0, a1, b1, Qstar, cv1, cv0) {
    invisible(.Call(`_errum_parm_update_nomiss`, N, J, K, nClass, Y, X_biject, B0, B1, CLASS, pis, Q, MU, vv, CLtable, v0, v1, d0, pistar, rstar, a0, b0, a1, b1, Qstar, cv1, cv0))
}

update_Gamma_Delta_MVN <- function(N, V, K, J, Y, Gamma, deltas, X, diagXpX, w2, nu, bnu) {
    .Call(`_errum_update_Gamma_Delta_MVN`, N, V, K, J, Y, Gamma, deltas, X, diagXpX, w2, nu, bnu)
}

OddsRatio <- function(N, J, Yt) {
    .Call(`_errum_OddsRatio`, N, J, Yt)
}

uppertri_matrix_logical_gt <- function(J, A, B) {
    .Call(`_errum_uppertri_matrix_logical_gt`, J, A, B)
}

rRUM_mvnQ_Gibbs <- function(Y, K, X, v0, v1, cv0, cv1, bnu, burnin = 1000L, chain_length = 10000L, verbose = FALSE) {
    .Call(`_errum_rRUM_mvnQ_Gibbs`, Y, K, X, v0, v1, cv0, cv1, bnu, burnin, chain_length, verbose)
}

